/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.tipo_ingreso;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.SQLiteConnectionHolder;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class SQLiteTipoIngresoDAO implements TipoIngresoDAO {

  private static final Logger log = LogManager.getLogger(SQLiteTipoIngresoDAO.class);
  private ConnectionHolder connectionHolder;

  public SQLiteTipoIngresoDAO() {
    this.connectionHolder = new SQLiteConnectionHolder();
  }

  public SQLiteTipoIngresoDAO(ConnectionHolder connectionHolder) {
    this.connectionHolder = connectionHolder;
  }

  @Override
  public List<TipoIngreso> getAll() {
    log.debug("Se intentara conseguir todos los TipoIngreso");
    List<TipoIngreso> tiposIngresoList = new ArrayList<>();
    String query = "select * from tipos_ingreso";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        try (ResultSet rs = ps.executeQuery()) {
          while (rs.next()) {
            TipoIngreso tipoIngreso = new TipoIngreso();
            tipoIngreso.setId(rs.getInt("id"));
            tipoIngreso.setNombre(rs.getString("nombre"));
            tiposIngresoList.add(tipoIngreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir todos los TipoIngreso", e);
    }
    log.debug("Se consiguieron " + tiposIngresoList.size() + " TiposIngreso");
    return tiposIngresoList;
  }

  @Override
  public Optional<TipoIngreso> getById(int id) {
    log.debug("Se intentara conseguir un TipoIngreso con id " + id);
    TipoIngreso tipoIngreso = null;
    String query = "select * from tipos_ingreso where id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, id);
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            tipoIngreso = new TipoIngreso();
            tipoIngreso.setId(rs.getInt("id"));
            tipoIngreso.setNombre(rs.getString("nombre"));
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir un TipoIngreso con id " + id);
    }
    log.debug("Se consiguio el TipoIngreso " + tipoIngreso);
    return Optional.ofNullable(tipoIngreso);
  }

  @Override
  public Optional<TipoIngreso> getByNombre(String nombre) {
    log.debug("Se intentara conseguir un TipoIngreso con nombre " + nombre);
    TipoIngreso tipoIngreso = null;
    String query = "select * from tipos_ingreso where nombre = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setString(1, nombre);
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            tipoIngreso = new TipoIngreso();
            tipoIngreso.setId(rs.getInt("id"));
            tipoIngreso.setNombre(rs.getString("nombre"));
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir un TipoIngreso con nombre " + nombre);
    }
    log.debug("Se consiguio el TipoIngreso " + tipoIngreso);
    return Optional.ofNullable(tipoIngreso);
  }

}
